#include <iostream>
#include <fstream>
#include <vector>
#include <string>

#define ERR_OK (0)
#define ERR_WA (1)
#define ERR_PE (2)
#define ERR_UH (3)

int getHammingRadius(const std::vector<std::string> &str, const std::string &top) {

	int dis = -1;
	for (const auto &s: str) {
		int d = 0; for (int i = 0; i < top.size(); ++ i) d += (s[i] != top[i]);
		if ((dis >= 0) && (d != dis)) return -1;
		dis = d;
	}
	return dis;
}

int main(int argc, char *argv[]) {

	std::vector<std::string> str(4); std::ifstream finp(argv[1]);
	for (auto &s: str) finp >> s;

	std::string out; std::ifstream fout(argv[2]);
	if (!fout.is_open()) {
		std::cout << "File not found!\n";
		return ERR_PE;
	}
	fout >> std::ws;
	fout >> out;
	for (auto c: out) {
		if ((c != 'A') && (c != 'B') && (c != 'C') && (c != 'D')) {
		std::cout << "Invalid chars!\n";
		return ERR_PE;
		}
	}
	if (out.size() && (out.size() != str[0].size())) {
		std::cout << "Incorrect size!\n";
		return ERR_WA;
	}

	std::string ans; std::ifstream fans(argv[3]);
	fout >> std::ws;
	fans >> ans;

	int d2 = getHammingRadius(str, out);
	int d1 = getHammingRadius(str, ans);
	if (d1 < 0) {
		std::cout << "Invalid radius!\n";
		return ERR_UH;
	}

	if (!out.size()) {
		if (ans.size()) {
		std::cout << "Empty string!\n";
		return ERR_WA;
		}
		return ERR_OK;
	}
	if (d2 < 0) {
		std::cout << "Invalid radius!\n";
		return ERR_WA;
	}

	if (!ans.size()) {
		std::cout << "Empty string!\n";
		return ERR_UH;
	}

	if (d1 > d2) {
		std::cout << "rad: " << d1;
		std::cout << " > " << d2;
		std::cout << "\n";
		return ERR_UH;
	}
	if (d1 < d2) {
		std::cout << "rad: " << d1;
		std::cout << " < " << d2;
		std::cout << "\n";
		return ERR_WA;
	}
	std::cout << "rad: " << d1;
	std::cout << "\n";

	return ERR_OK;
}
